using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using SimpleSample;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.Droid;
using Xamarin.Forms.Platform.Android;
using Com.Syncfusion.Charts;
using Java.Util;
using System.Collections.ObjectModel;

[assembly: ExportRenderer(typeof(ChartExt), typeof(SimpleSample.Droid.CustomRenderer))]

namespace SimpleSample.Droid
{
    public class CustomRenderer : SfChartRenderer
    {
        internal static ChartExt Chart { get; set; }

        public CustomRenderer()
        {

        }
        protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            Chart = e.NewElement as ChartExt;

            if (Control != null)
            {
                 for (int i = 0; i < Control.Series.Size(); i++)
                {
                    if (Control.Series.Get(i).GetType() == typeof(PieSeries))
                    {
                        (Control.Series.Get(i) as ChartSeries).DataMarkerLabelCreated += CustomRenderer_DataMarkerLabelCreated;
                    }
                }
            }
        }

        ObservableCollection<Model> data;
        private void CustomRenderer_DataMarkerLabelCreated(object sender, ChartSeries.DataMarkerLabelCreatedEventArgs e)
        {
            data = Chart.Series[0].ItemsSource as ObservableCollection<Model>;
            e.P0.Label = (data[e.P0.Index] as Model).Name.ToString() + ":" + e.P0.Label.ToString();
        }
    }
}
