﻿using System;
using System.Collections.Generic;
using System.Linq;

using Foundation;
using UIKit;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using Syncfusion.SfChart.iOS;
using SimpleSample.iOS;
using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.iOS;
using SimpleSample;
using Xamarin.Forms;
using System.Collections;

namespace SimpleSample.iOS
{
    // The UIApplicationDelegate for the application. This class is responsible for launching the 
    // User Interface of the application, as well as listening (and optionally responding) to 
    // application events from iOS.
    [Register("AppDelegate")]
    public partial class AppDelegate : global::Xamarin.Forms.Platform.iOS.FormsApplicationDelegate
    {
        //
        // This method is invoked when the application has loaded and is ready to run. In this 
        // method you should instantiate the window, load the UI into it and then make the window
        // visible.
        //
        // You have 17 seconds to return from this method, or iOS will terminate your application.
        //
        public override bool FinishedLaunching(UIApplication app, NSDictionary options)
        {
            global::Xamarin.Forms.Forms.Init();
            LoadApplication(new App());
			new SfChartRenderer ();

			Xamarin.Forms.Forms.ViewInitialized += (object sender, Xamarin.Forms.ViewInitializedEventArgs e) => 
			{
				if(e.NativeView is SFChart)
				{
					(e.NativeView as SFChart).Delegate = new CustomDelegate(e.View as SfChart);
				}
			};

            return base.FinishedLaunching(app, options);
        }
    }

	public class CustomDelegate: ChartDelegate
	{
		public SfChart Chart {
			get;
			set;
		}

		public CustomDelegate(SfChart chart):base(chart)
		{
			this.Chart = chart;
		}

		public override NSString GetFormattedDataMarkerLabel (SFChart chart, NSString label, nint index, SFSeries series)
		{
			string formattedLabel = label.ToString ();

			if (series.GetType() == typeof(SFPieSeries) ) {

				int seriesIndex = (int)chart.IndexOfSeries (series);

				IList data = Chart.Series [seriesIndex].ItemsSource as IList;

				formattedLabel = (data [(int)index] as Model).Name.ToString () + ":" + label.ToString ();
			
			}

		return new NSString (formattedLabel);
		}
				
	}

}
